<?php
namespace App\Http\Controllers;

use App\Repositories\CmsContentTemplateRepository;
use App\Repositories\CmsContentTemplateSetRepository;
use App\Transformers\CmsContentTemplateTransformer;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use League\Fractal\Resource\Collection;
use League\Fractal\Manager;
use Illuminate\Validation\Rule;
use League\Fractal\Pagination\IlluminatePaginatorAdapter;
/**
 * Created by PhpStorm.
 * User: qinyaer
 * Date: 2019/4/29
 * Time: 下午18:37
 */

class CmsContentTemplateSetController extends BaseController
{
    public function __construct(CmsContentTemplateSetRepository $cmsContentTemplateSetRepository)
    {
        $this->cmsContentSetTemplate = $cmsContentTemplateSetRepository;
    }


    //banner设置
    public function bannerSet(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'rule' => 'required',
            'tpl_id' => 'required|integer',
            'area_type' => ['required', Rule::in(0,1,2,3)],
        ]);
        if ($validator->fails()) {
            return $this->response->error($validator->errors()->first(), 500);
        }

        return  $this->cmsContentSetTemplate->bannerSet($request->all());

    }

    //专题广告设置
    public function advertisement(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'rule' => 'required',
            'tpl_id' => 'required|integer',
            'area_type' => ['required', Rule::in(0,1,2,3)],
        ]);
        if ($validator->fails()) {
            return $this->response->error($validator->errors()->first(), 500);
        }

        return  $this->cmsContentSetTemplate->advertisementSet($request->all());

    }

    //商品楼层设置
    public function floorSet(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'rule' => 'required',
            'tpl_id' => 'required|integer',
            'area_type' => ['required', Rule::in(0,1,2,3)],
        ]);
        if ($validator->fails()) {
            return $this->response->error($validator->errors()->first(), 500);
        }

        return  $this->cmsContentSetTemplate->floorSet($request->all());

    }

    //分类专题设置
    public function categorySet(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'rule' => 'required',
            'tpl_id' => 'required|integer',
            'area_type' => ['required', Rule::in(0,1,2,3)],
        ]);
        if ($validator->fails()) {
            return $this->response->error($validator->errors()->first(), 500);
        }

        return  $this->cmsContentSetTemplate->categorySet($request->all());

    }


    //内容发布
    public function release(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'tpl_id' => 'required|integer',
        ]);
        if ($validator->fails()) {
            return $this->response->error($validator->errors()->first(), 500);
        }

        return  $this->cmsContentSetTemplate->release($request->all());
        
    }


}