<?php

namespace App\Repositories;


use App\Models\CmsContentTemplate;
use Symfony\Component\HttpKernel\Exception\HttpException;

class CmsContentTemplateRepository {
    public function __construct(CmsContentTemplate $cmsContentTemplate) {

        $this->cmsContentTemplate = $cmsContentTemplate;
    }
    //模板列表
    public function index($request)
    {
        $where = [];
        if(isset($request['id'])){
            $where[] = ['id', '=', $request['id']];
        }
        if (isset($request['is_open'])){
            $where[] = ['is_open',$request['is_open']];
        }

        return $this->cmsContentTemplate->where($where)->orderBy('id', 'asc')->paginate(20);

    }

    /**
     * 新建模板
     */
    public function create($request)
    {
        if($this->cmsContentTemplate->where('title', trim($request['title']))->exists()){
            throw new HttpException(500, '该模块已经存在');
        }

        $subject = [
            'title' => $request['title'],
            'city_id' => $request['city_id'],
            'city_name' => $request['city_name'],
            'apply_type' => $request['apply_type'],
            'is_open' => $request['is_open'],
        ];

        if (!$this->cmsContentTemplate->create($subject)) {
            throw new HttpException(500, '添加失败');
        }
    }

}